import { ICore, IModLoaderAPI } from 'modloader64_api/IModLoaderAPI';
import { IRomHeader } from 'modloader64_api/IRomHeader';
import { IGlobalContext, ILink, IOOTCore, IOotHelper, ISaveContext, IKeyManager } from 'modloader64_api/OOT/OOTAPI';
import { ActorManager } from './OOT/ActorManager';
import { CommandBuffer } from './OOT/CommandBuffer';
export declare class OcarinaofTime implements ICore, IOOTCore {
    header: string;
    ModLoader: IModLoaderAPI;
    payloads: string[];
    link: ILink;
    save: ISaveContext;
    global: IGlobalContext;
    helper: IOotHelper;
    commandBuffer: CommandBuffer;
    actorManager: ActorManager;
    keyManager: IKeyManager;
    eventTicks: Map<string, Function>;
    isSaveLoaded: boolean;
    last_known_scene: number;
    touching_loading_zone: boolean;
    frame_count_reset_scene: number;
    rom_header: IRomHeader;
    preinit(): void;
    init(): void;
    postinit(): void;
    onTick(): void;
    onInject(evt: any): void;
}
