import pluginLoader from './pluginLoader';
import { ILogger, IConfig } from 'modloader64_api/IModLoaderAPI';
import IModLoaderConfig from './IModLoaderConfig';
import NetworkEngine from './NetworkEngine';
import IConsole from 'modloader64_api/IConsole';
import { EventBus } from 'modloader64_api/EventHandler';
import { IGUITunnel } from 'modloader64_api/GUITunnel';
export declare const internal_event_bus: EventBus;
declare class ModLoader64 {
    logger: ILogger;
    config: IConfig;
    data: IModLoaderConfig;
    plugins: pluginLoader;
    rom_folder: string;
    mods_folder: string;
    roms: string[];
    Server: NetworkEngine.Server;
    Client: NetworkEngine.Client;
    rom_path: string;
    emulator: IConsole;
    tunnel: IGUITunnel;
    done: boolean;
    constructor(logger: any);
    start(): void;
    private preinit;
    private init;
    private postinit;
}
export default ModLoader64;
