import { ILogger, IConfig, IPlugin, ICore } from 'modloader64_api/IModLoaderAPI';
import IMemory from 'modloader64_api/IMemory';
import { ILobbyManager, INetworkPlayer } from 'modloader64_api/NetworkHandler';
import IConsole from 'modloader64_api/IConsole';
import { IRomHeader } from 'modloader64_api/IRomHeader';
import NetworkEngine from './NetworkEngine';
declare class pluginLoader {
    plugin_directories: string[];
    core_plugins: any;
    plugin_folders: string[];
    plugins: IPlugin[];
    selected_core: string;
    loaded_core: ICore;
    config: IConfig;
    logger: ILogger;
    onTickHandle: Function;
    onFakeFrameHandler: any;
    internalFrameCount: number;
    header: IRomHeader;
    constructor(dirs: string[], config: IConfig, logger: ILogger);
    verifySignature(file: string, key: string, sig: string): boolean;
    registerCorePlugin(name: string, core: any): void;
    private registerPlugin;
    private processFolder;
    loadPluginsConstruct(header: IRomHeader, overrideCore?: string): void;
    loadPluginsPreInit(manager: ILobbyManager): void;
    loadPluginsInit(me: INetworkPlayer, iconsole: IConsole, net: NetworkEngine.Client): void;
    loadPluginsPostinit(emulator: IMemory, iconsole: IConsole): void;
}
export default pluginLoader;
